/* 
 * @Program for Creating a DocumentFragment Subtree and Appending to the Document
 * Creatingdocumentfragment.java 
 * Author:-RoseIndia Team
 * Date:-10-Jun-2008
 */

import java.io.*;
import org.w3c.dom.*;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

public class Creatingdocumentfragment {

    public static void main(String[] args)throws Exception {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        Document doc = factory.newDocumentBuilder().parse(new File("2.xml"));
       new Creatingdocumentfragment().newFragment(doc); 
    }
    public void newFragment(Document doc)throws Exception{
         
        Element root = doc.getDocumentElement();
        DocumentFragment fragment = doc.createDocumentFragment();
        Element person = Fragmenttree(doc,"Girish","developer");
        fragment.appendChild(person);
        person = Fragmenttree(doc,"Komal","Developer");
        fragment.appendChild(person);
        root.appendChild(fragment);
         TransformerFactory factory = TransformerFactory.newInstance();
        Transformer transformer = factory.newTransformer();

        transformer.setOutputProperty(OutputKeys.INDENT, "yes");

        // create string from xml tree
        StringWriter sw = new StringWriter();
        StreamResult result = new StreamResult(sw);
        DOMSource source = new DOMSource(doc);
        transformer.transform(source, result);
        String xmlString = sw.toString();
        System.out.println(xmlString);
    }
    public Element Fragmenttree(Document doc,String name,String Status) {
        Element element = doc.createElement("name");
        Text text = doc.createTextNode(name);
        element.appendChild(text);

        Element status = doc.createElement("Status");
        Text text1 = doc.createTextNode(Status);
        status.appendChild(text1);
        
        Element Person = doc.createElement("person");
        Person.appendChild(element);
        Person.appendChild(status);
        return(Person);
       
    }
}
